local L = DBM_VictorySound_Translations

local default_settings = {
    enabled = true,
	wipeSound = true,
    victorySound = true,
    startSound = true,
    wipePath = 'defeat.mp3',
    victoryPath = 'victory.mp3',
    startPath = 'start.mp3',
}


local wipeSoundList = {
    'defeat.mp3',
    'PIRdefeat.mp3',
    'SMB3defeat.mp3',
    'SMWdefeat.mp3',
    'KCwipe.mp3',
}

local victorySoundList = {
    'victory.mp3',
    'FFvictory.mp3',
    'FFvictoryclassic.mp3',
    'FFvictorylong.mp3',
    'SMB3victory.mp3',
    'SMBvictory.mp3',
}

local startSoundList = {
    'start.mp3',
    'FFstart.mp3',
    'WCstart.mp3',
}


DBM_VictorySound_Settings = {}
local settings = default_settings

--local settings = DBM_VictorySound_Options
local mainframe = CreateFrame("Frame", L.VictorySound_Options, UIParent)

local addDefaultOptions

local function toboolean(var) 
    if var then return true else return false end
end

local function createpanel()
    panel = DBM_GUI:CreateNewPanel(L.VictorySoundTab, "option")
        do
			local area = panel:CreateArea(L.AreaEnable, nil, 50, true)
			local enabled = area:CreateCheckButton(L.Activate, true)
            
            local area2 = panel:CreateArea(L.AreaGeneral, nil, 100, true)
            local wipeSound = area2:CreateCheckButton(L.VictorySound_Wipe, true)
            local victorySound = area2:CreateCheckButton(L.VictorySound_Victory, true)
            local startSound = area2:CreateCheckButton(L.VictorySound_Start, true)
            
			enabled:SetScript("OnClick", 		    function(self) settings.enabled = toboolean(self:GetChecked()) end)
			enabled:SetScript("OnShow", 		    function(self) self:SetChecked(settings.enabled) end)
           
            wipeSound:SetScript("OnClick", 		    function(self) settings.wipeSound = toboolean(self:GetChecked()) end)
			wipeSound:SetScript("OnShow", 		    function(self) self:SetChecked(settings.wipeSound) end)
            victorySound:SetScript("OnClick", 		function(self) settings.victorySound = toboolean(self:GetChecked()) end)
			victorySound:SetScript("OnShow", 		function(self) self:SetChecked(settings.victorySound) end)
            startSound:SetScript("OnClick", 		function(self) settings.startSound = toboolean(self:GetChecked()) end)
			startSound:SetScript("OnShow", 		function(self) self:SetChecked(settings.startSound) end)


            

            
			
            local resettool = area:CreateButton(L.Button_ResetSettings, 100, 16)
			resettool:SetPoint('BOTTOMRIGHT', area.frame, "TOPRIGHT", 0, 0)
			resettool:SetNormalFontObject(GameFontNormalSmall)
			resettool:SetHighlightFontObject(GameFontNormalSmall)
			resettool:SetScript("OnClick", function(self) 
				table.wipe(DBM_VictorySound_Settings)
				addDefaultOptions(settings, default_settings)

				DBM_GUI_OptionsFrame:Hide()
				DBM_GUI_OptionsFrame:Show()				
			end)
		end
        
    fileOptionsPanel = panel:CreateNewPanel(L.FileOptionsSubtab, "option")
        do
            local wipePathBox = -30
            local victoryPathBox = -140
            local startPathBox = -250
            
            local area3 = fileOptionsPanel:CreateArea(L.AreaPaths, nil, 360, true)
            local wipePath = area3:CreateEditBox(L.WipePath, settings.wipePath, 200)
            wipePath:SetPoint("TOPLEFT", area3.frame, "TOPLEFT", 27, wipePathBox)
            local victoryPath = area3:CreateEditBox(L.VictoryPath, settings.victoryPath, 200)
            victoryPath:SetPoint('TOPLEFT', area3.frame, "TOPLEFT", 27, victoryPathBox)
            local startPath = area3:CreateEditBox(L.StartPath, settings.startPath, 200)
            startPath:SetPoint('TOPLEFT', area3.frame, "TOPLEFT", 27, startPathBox)
            local wipePlay = area3:CreateButton(L.Button_Play, 100, 20)
			wipePlay:SetPoint('TOPLEFT', area3.frame, "TOPLEFT", 250, wipePathBox)
            local victoryPlay = area3:CreateButton(L.Button_Play, 100, 20)
			victoryPlay:SetPoint('TOPLEFT', area3.frame, "TOPLEFT", 250, victoryPathBox)
            local startPlay = area3:CreateButton(L.Button_Play, 100, 20)
			startPlay:SetPoint('TOPLEFT', area3.frame, "TOPLEFT", 250, startPathBox)
            
            wipeSoundListDropdown = { }
            for i=1, getn(wipeSoundList), 1 do
				table.insert(wipeSoundListDropdown, { text=wipeSoundList[i],value=i })
			end
            local wipeList = area3:CreateDropdown(L.WipeSoundList, wipeSoundListDropdown, settings.wipePath, function(value) settings.wipePath = wipeSoundList[value] wipePath:SetText(wipeSoundList[value])  end, 200)
			wipeList:SetScript("OnShow", function(self) 
                table.wipe(wipeSoundListDropdown)
                for i=1, getn(wipeSoundList), 1 do
                    table.insert(wipeSoundListDropdown, { text=wipeSoundList[i],value=i })
                end
			end)
			wipeList:SetPoint("TOPLEFT", area3.frame, "TOPLEFT", 0, wipePathBox-40)
            
            victorySoundListDropdown = { }
            for i=1, getn(victorySoundList), 1 do
				table.insert(victorySoundListDropdown, { text=victorySoundList[i],value=i })
			end
            local victoryList = area3:CreateDropdown(L.VictorySoundList, victorySoundListDropdown, settings.victoryPath, function(value) settings.victoryPath = victorySoundList[value] victoryPath:SetText(victorySoundList[value])  end, 200)
			victoryList:SetScript("OnShow", function(self) 
                table.wipe(victorySoundListDropdown)
                for i=1, getn(victorySoundList), 1 do
                    table.insert(victorySoundListDropdown, { text=victorySoundList[i],value=i })
                end
			end)
			victoryList:SetPoint("TOPLEFT", area3.frame, "TOPLEFT", 0, victoryPathBox-40)
            
            startSoundListDropdown = { }
            for i=1, getn(startSoundList), 1 do
				table.insert(startSoundListDropdown, { text=startSoundList[i],value=i })
			end
            local startList = area3:CreateDropdown(L.StartSoundList, startSoundListDropdown, settings.startPath, function(value) settings.startPath = startSoundList[value] startPath:SetText(startSoundList[value])  end, 200)
			startList:SetScript("OnShow", function(self) 
                table.wipe(startSoundListDropdown)
                for i=1, getn(startSoundList), 1 do
                    table.insert(startSoundListDropdown, { text=startSoundList[i],value=i })
                end
			end)
			startList:SetPoint("TOPLEFT", area3.frame, "TOPLEFT", 0, startPathBox-40)
	
           
            wipePath:SetScript("OnTextChanged", 	function(self) settings.wipePath = self:GetText() end)
			wipePath:SetScript("OnShow", 		    function(self) self:SetText(settings.wipePath) end)
            victoryPath:SetScript("OnTextChanged", 	function(self) settings.victoryPath = self:GetText() end)
			victoryPath:SetScript("OnShow", 		function(self) self:SetText(settings.victoryPath) end)
 
            startPath:SetScript("OnTextChanged", 	function(self) settings.startPath = self:GetText() end)
			startPath:SetScript("OnShow", 		function(self) self:SetText(settings.startPath) end)
            
            wipePlay:SetScript("OnClick",           function(self) PlaySoundFile("Interface\\AddOns\\DBM-VictorySound\\sounds\\" .. settings.wipePath) end)
            victoryPlay:SetScript("OnClick",        function(self) PlaySoundFile("Interface\\AddOns\\DBM-VictorySound\\sounds\\" .. settings.victoryPath) end)
            startPlay:SetScript("OnClick",        function(self) PlaySoundFile("Interface\\AddOns\\DBM-VictorySound\\sounds\\" .. settings.startPath) end)
      
            local resettool = area3:CreateButton(L.Button_ResetSettings, 100, 16)
			resettool:SetPoint('BOTTOMRIGHT', area3.frame, "TOPRIGHT", 0, 0)
			resettool:SetNormalFontObject(GameFontNormalSmall)
			resettool:SetHighlightFontObject(GameFontNormalSmall)
			resettool:SetScript("OnClick", function(self) 
				table.wipe(DBM_VictorySound_Settings)
				addDefaultOptions(settings, default_settings)

				DBM_GUI_OptionsFrame:Hide()
				DBM_GUI_OptionsFrame:Show()				
			end)

       end
end

DBM:RegisterOnGuiLoadCallback(createpanel, 25)

function addDefaultOptions(t1, t2)
	for i, v in pairs(t2) do
		if t1[i] == nil then
			t1[i] = v
		elseif type(v) == "table" then
			addDefaultOptions(v, t2[i])
		end
	end
end

do
    mainframe:SetScript("OnEvent", function(self, event, ...)
        if event == "ADDON_LOADED" and select(1, ...) == "DBM-VictorySound" then
            -- Update settings of this Addon
            settings = DBM_VictorySound_Settings
            addDefaultOptions(settings, default_settings)
        end
    end)
        
    -- lets register the Events
    mainframe:RegisterEvent("ADDON_LOADED")
end

function DBM:VS_StartCombat(mod, delay, synced)
    DBM:SavedStartCombat(mod, delay, synced);
    
    if settings.enabled and settings.startSound and delay==0 then
        -- Plays on start
        PlaySoundFile("Interface\\AddOns\\DBM-VictorySound\\sounds\\" .. settings.startPath)
    end
end

DBM.SavedStartCombat = DBM.StartCombat;
DBM.StartCombat = DBM.VS_StartCombat;

function DBM:VS_EndCombat(mod, wipe)
    DBM:SavedEndCombat(mod, wipe);
    if settings.enabled then
    if wipe and settings.wipeSound then
        -- Plays on wipe
        PlaySoundFile("Interface\\AddOns\\DBM-VictorySound\\sounds\\" .. settings.wipePath)
    elseif not wipe and settings.victorySound then
        -- Plays on boss kill
        PlaySoundFile("Interface\\AddOns\\DBM-VictorySound\\sounds\\" .. settings.victoryPath)
    end
    end
end

DBM.SavedEndCombat = DBM.EndCombat;
DBM.EndCombat = DBM.VS_EndCombat;